/*
    This file contains definition of constants, which are used for adding
    service properties to editable widgets.
*/

#ifndef CONSTANTS_H
#define CONSTANTS_H
// name of list, which stores names of read-only properties.
// Allows to prevent some props from editing
const char READ_ONLY_LIST_PROP_NAME  [] = "__q7b_readOnlyList" ;
// Name of property, which marks widget as deleted
const char DELETED_PROP_NAME  [] = "__q7b_ff_deleted" ;
//name of property, which stores widget tab index
const char TABINDEX_PROP_NAME [] = "__q7b_ff_tabindex" ;
// name of list, which stores internal, invisible in PropertyEditor, properties
const char LAYOUT_KIND_PROP_NAME[] = "__q7b_layout_kind" ;
const char INTERNAL_PROPS_LIST_NAME [] = "__q7b_internal_props" ;
// name of property, which defines widget x relative to parent width
const char REL_X [] = "relativeX" ;
// name of property, which defines widget y relative to parent height
const char REL_Y [] = "relativeY" ;
// name of property, which defines widget width relative to parent width
const char REL_W [] = "relativeWidth" ;
// name of property, which defines widget height relative to parent height
const char REL_H [] = "relativeHeight" ;
const char EN_REL_X [] = "enableRelX" ;
const char EN_REL_Y [] = "enableRelY" ;
const char EN_REL_W [] = "enableRelW" ;
const char EN_REL_H [] = "enableRelH" ;

const char REL_L [] = "relativeLeft" ;
const char REL_R [] = "relativeRight" ;
const char REL_T [] = "relativeTop" ;
const char REL_B [] = "relativeBottom" ;

const char EN_REL_L [] = "enableRelLeft" ;
const char EN_REL_R [] = "enableRelRight" ;
const char EN_REL_T [] = "enableRelTop" ;
const char EN_REL_B [] = "enableRelBottom" ;


// name of property, which marks a widget as used for selection
const char SEL_SQUARES_MARK[] = "__q7b_sel_sq_mark" ;
const char METAPROPERTY_REPLACEMENTS [] = "__q7b_prop_repl" ;
const char Z_ORDER [] = "Z_ORDER" ;

#endif // CONSTANTS_H
