/*
This file containes the declaration of ObjectTreeWindow class, which
allows to view widgets relationship structure in tree form.
*/

#ifndef OBJECTTREEWINDOW_H
#define OBJECTTREEWINDOW_H

#include <QWidget>
#include <QTreeWidget>
#include <QTreeWidgetItem>
#include <QPointer>
//Provides tree-like representation of widgets hierarhy.
class FormMaket ;
class WidgetManager ;
class ObjectTreeWindow : public QWidget
{
    Q_OBJECT

    QTreeWidget * tree ;
    FormMaket * m ;
    WidgetManager * WM ;
    //recursive function, which creates a tree of QTreeWidgetItem objects
    //according to a hierarhy of w children.
    void scan ( QTreeWidgetItem * item , QWidget * w ) ;
    QHash < QTreeWidgetItem * , QPointer < QWidget > > hash ;
    QHash < QString , QTreeWidgetItem * > itemsByName ;
public:
    explicit ObjectTreeWindow ( QWidget *parent = 0 ) ;
signals:
    //emitted when user clickes on an item of the a tree.
    void selectWidgets ( QList < QPointer < QWidget > > list , bool withControl ) ;

public slots:
    //makes ObjectTreeWindow refresh a tree.
    void scanMaket ( ) ;
    //makes ObjectTreeWindow update selection of tree items
    void selectionChanged () ;
    //sets a maket, which is handled
    void setMaket ( FormMaket * maket ) ;
    // sets a WidgetManager
    void wmChanged ( WidgetManager * w ) ;

private slots :
    // connected to ItemClicked signal of tree
    void itemClicked  ( QTreeWidgetItem * item, int column ) ;
    // connected to itemSelectionChanged signal of tree
    void itemSelectionChanged() ;
};

#endif // OBJECTTREEWINDOW_H
