/*
    This file containes declarations of ObjectPropertiesModel class,
    which provides model for interaction with QObject properties, and
    PropertyEditor, which provides table-based interface for viewing
    and editing these properties.

    Current FontEditor realisation is absolutely awful! Need to
    refactor it.
*/
#ifndef PROPERTYEDITOR_H
#define PROPERTYEDITOR_H

#include <QWidget>
#include <QAbstractTableModel>
#include <QAbstractItemModel>
#include <QTableView>
#include <QPointer>
#include <QStyledItemDelegate>
#include <QLineEdit>
#include <QSpinBox>
#include <QLabel>
#include <QPushButton>
#include <QTimer>
#include <QTreeView>
//Model class for Model/View-based property editor. Allows to access object's properties.
class WidgetManager ;


class PropertyDelegate ;
class PropertyEditor : public QWidget
{
    Q_OBJECT
    // Displays properties and allows editing feature
    //QTableView * view ;
    QTreeView * view ;
    //bool selectionIsChanging ;

    WidgetManager * WM ;
    PropertyDelegate * deleg ;

    QHash < QString , bool > expandState;
public:
    explicit PropertyEditor ( QWidget *parent = 0);

signals:
    // Emitted when properties of target are changed
    void propsEdited ( QVariantMap v ) ;
public slots :
    //deletes model assigned to QTableView and creates new model for selected object
    void selectionChanged (  ) ;
    // Called when current WidgetManager changes
    void wmChanged ( WidgetManager * w ) ;
private slots :
};


class PropertyDelegate : public QStyledItemDelegate
{
    Q_OBJECT
    QFont lastEditedFont ;
    //QModelIndex mIndex ;
    //ObjectPropertiesModel * model ;
public:
    PropertyDelegate (QWidget *parent = 0) : QStyledItemDelegate (parent) {}

    QWidget *createEditor (QWidget *parent, const QStyleOptionViewItem &option,
                           const QModelIndex &index) const;
    void setEditorData (QWidget *editor, const QModelIndex &index) const;
    void setModelData (QWidget *editor, QAbstractItemModel *model,
                       const QModelIndex &index) const;
private slots:
    void fin( QWidget * w ) ;
signals:
    void fontEdited( const QModelIndex & mIndex , QFont font ) ;
};

class GeometryEditor : public QWidget
{
    Q_OBJECT
    QSpinBox * widthEdit ;
    QSpinBox * heightEdit ;
    QSpinBox * leftEdit ;
    QSpinBox * topEdit ;
    void paintEvent (QPaintEvent *) ;
public:
    GeometryEditor (QWidget *parent = 0)  ;
    void setRect ( QRect rect ) ;
    QRect getRect () ;
} ;

class SizeEditor : public QWidget
{
    Q_OBJECT
    QSpinBox * widthEdit ;
    QSpinBox * heightEdit ;
    void paintEvent (QPaintEvent *) ;
public:
    SizeEditor (QWidget *parent = 0)  ;
    void setSize ( QSize s ) ;
    QSize getSize () ;
} ;

class PointEditor : public QWidget
{
    Q_OBJECT

    QSpinBox * xEdit ;
    QSpinBox * yEdit ;
    void paintEvent (QPaintEvent *) ;
public:
    PointEditor (QWidget *parent = 0)  ;
    void setPoint ( QPoint p ) ;
    QPoint getPoint () ;
} ;

class FontEditor : public QWidget
{
    Q_OBJECT

    QFont font ;
    QPushButton * b ;
    QLabel *l ;
    void paintEvent ( QPaintEvent *) ;
    QTimer timer ;
    QModelIndex index ;
public:
    FontEditor ( QFont f , const QModelIndex &index , QWidget *parent = 0)  ;
    void setFont ( QVariant f ) ;
    QFont getFont () ;
    const QModelIndex & getIndex() ;
signals :
    void finished ( QWidget * editor ) ;
private slots:
    void buttonPress () ;

} ;
#endif // PROPERTYEDITOR_H
