#ifndef QOBPROPMODEL_H
#define QOBPROPMODEL_H

#include <QAbstractItemModel>

#include <QFont>

class OPTreeItem
{
public:

    enum Role
    {
        GROUP ,
        PROP ,
        SUBPROP
    };
private:
    QVariantList d ;
    Role r ;
    QList < OPTreeItem * > childItems ;
    OPTreeItem * parentItem ;
public :
    OPTreeItem ( OPTreeItem *parent = 0 ) ;
    ~OPTreeItem () ;
    Role role() ;
    void setRole ( Role role ) ;
    OPTreeItem *child(int number);
    int childCount() const;
    int columnCount() const;
    QVariant data(int column) const;
    bool insertChildren(int position, int count);
    //bool insertColumns(int position, int columns);
    OPTreeItem *parent();
    //bool removeChildren(int position, int count);
    //bool removeColumns(int position, int columns);
    int childNumber() const;
    bool setData( int column, const QVariant &value ) ;
} ;


class QObPropModel : public QAbstractItemModel
{
    Q_OBJECT
    void setupModelData(const QObject * target , OPTreeItem * parent ) ;
    OPTreeItem *getItem(const QModelIndex &index) const;

    OPTreeItem *rootItem;
    QObject * trg ;

    QColor createRowColor ( int row , int maxRow ) const ;
public:
    explicit QObPropModel( QObject *target , QObject *parent = 0 ) ;
    ~QObPropModel() ;
    QVariant data(const QModelIndex &index, int role) const;
    QVariant headerData(int section, Qt::Orientation orientation,
                        int role = Qt::DisplayRole) const;

    QModelIndex index(int row, int column,
                      const QModelIndex &parent = QModelIndex()) const;
    QModelIndex parent(const QModelIndex &index) const;

    int rowCount(const QModelIndex &parent = QModelIndex()) const;
    int columnCount(const QModelIndex &parent = QModelIndex()) const;
    Qt::ItemFlags flags(const QModelIndex &index) const;
    bool setData(const QModelIndex &index, const QVariant &value,
                 int role = Qt::EditRole);
    QObject * target() ;

signals:
    void propsEdited ( QVariantMap v ) ;
public slots:
private slots:
    void fontEdited( const QModelIndex & mIndex , QFont font ) ;
};

#endif // QOBPROPMODEL_H
