/*
    This file containes declaration of TabOrderEditWidget class, which is used
    in tab-order editing process
*/

#ifndef TABORDEREDITWIDGET_H
#define TABORDEREDITWIDGET_H

#include <QLabel>
#include <QPointer>
class TabOrderEditWidget : public QLabel
{
    Q_OBJECT
    QPointer < QWidget > target ;
    // stores all TabOrderEditWidget objects
    static QList < QPointer < TabOrderEditWidget > > list ;
    // stores the tab order index, which will be assigned to the next widget
    static int editIndex ;
    // stores index of this TabOrderEditWidget
    int index ;
    // sets index of this TabOrderEditWidget and refreshes displayeble text
    void setIndex ( int i ) ;
public:
    explicit TabOrderEditWidget ( QWidget * trg , QWidget *parent = 0 ) ;
    // Sets tab-order of widgets by QWidget::setTabOrder
    static void finishEditing () ;
signals :
    
public slots :
private slots :
    // refreshes indexes of current and previous TabOrderEditWidget
    void clickedSlot ( QString ) ;
} ;

#endif // TABORDEREDITWIDGET_H
